/**************************
	Google Bookmarks Sidebar
	By Neo101
	Version 1.0.1
**************************/

checkSettingsFile()

var userName = decodeURIComponent( decodeTxt( readSetting('userName') ) )
var password = decodeURIComponent( decodeTxt( readSetting('password') ) )

var authURL = 'https://www.google.com/accounts/LoginAuth'
var showTooltip = readSetting('showTooltip', '1')
var autoUpdateTime = parseInt( readSetting('autoUpdateTime', '0') )
var sortTags = readSetting('sortTags', '1')
var sortFavorites = readSetting('sortFavorites', '1')
	
var baseURL = 'http://www.google.com/bookmarks/'
var favoritesCache = 'cache/favorites.html'

var favoritesHTML = ''
var posts = new Array()

var xmlhttp
var authKey

var editElement
var isAddFavorite = true
var tryLogin = true

var functionToRun = ''
var configVisible = false

window.onload = function(){
	if(userName == '' || password == ''){
		displaySettings()
		document.getElementById('menu').innerHTML = 'Google Bookmarks Sidebar'
		document.getElementById('settingsLinks').style.display = 'none'
		document.getElementById('links').style.display = 'none'
	} else {
		viewFavorites()
		//getLastUpdateTime()
		downloadFavorites()
		//functionToRun = downloadFavorites
		//login()
		
	}
	
	setSettingsForm()
	
	setAutoUpdate()
}

document.onkeydown = function() {
	if( configVisible == true || event.keyCode < 65 || event.keyCode > 90 || event.altKey || event.ctrlKey){
		return
	}
	document.getElementById('searchbox').focus()
}


function setAutoUpdate(){
	if(isNaN(autoUpdateTime) || autoUpdateTime < 5){
		return
	}
	var time = autoUpdateTime * 1000 * 60
	window.setInterval('downloadFavorites()', time)
}


function logout(){
	var url = 'https://www.google.com/accounts/Logout?continue=http%3A%2F%2Fwww.google.com'
	
	loadXMLDoc(url, 'logout', onResponseLogout)
}

function login(){
	var url = authURL
	var data = 'Email='+userName+'&Passwd='+password+'&nui=1&hl=en&rmShown=1&null=Sign+in&service=bookmarks&continue=http://www.google.com/'
    writeFile(favoritesCache, '')
	document.getElementById('favorites').innerHTML = 'Logging in...'
	showError('Logging in...')
	loadXMLDoc(url, 'login', onResponseLogin, data)
}


function loadXMLDoc(url, type, stateChange, data){
	if(userName == '' || password == ''){
		showError('User information not defined!')
		return
	}
	
	try{
		xmlhttp = external.max_activex(SECURITY_ID, "Microsoft.XMLHTTP")
	}
	catch(err){
		showError('Could not load ActiveX object')
	}
	xmlhttp.onreadystatechange = stateChange
	
	if(type == 'login'){
		xmlhttp.open("POST", url, true)
		xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded; charset=UTF-8');
		xmlhttp.setRequestHeader('Referer','https://www.google.com/accounts/ServiceLogin');
	}
	else if(type == 'postFavorite'){
		xmlhttp.open("POST", url, true)
		xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded;');
		xmlhttp.setRequestHeader('Referer','null');
		xmlhttp.setRequestHeader('User-Agent','Mozilla/5.0 (Windows; U; Windows NT 5.1) Firefox/2.0.0.3 GoogleToolbarFF');
	} else if(type == 'deleteFavorite'){
		xmlhttp.open("POST", url, true)
		xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded; charset=UTF-8');
		xmlhttp.setRequestHeader('Referer','null');
		xmlhttp.setRequestHeader('User-Agent','GoogleToolbarFF');
	} else {
		xmlhttp.open("GET", url, true)
	}
	xmlhttp.send(data)
	
	
}


function checkReadyState(obj){
	if(obj.readyState == 4){
		if(obj.status == 200 || obj.status == 201){
			return true;
		}
		else if(obj.status == 401 || obj.status == 403){
			var message = 'Could not login. Please check your '+
				'<a href="#" onclick="displaySettings()" style="color:red;text-decoration:underline">login information!</a>'
			showError(message)
			document.getElementById('favorites').innerHTML = message
		}
		else if(obj.status == 503){
			showError('Error 503: Please try again..')
		}
		else if(obj.status == 0){
			if(tryLogin == true){
				login()
	            tryLogin = false
			} else {
				var message = 'Could not login. Please check your '+
				'<a href="#" onclick="displaySettings()" style="color:red;text-decoration:underline">login information!</a>'
				showError(message)
				document.getElementById('favorites').innerHTML = message
			}
		}
		else{
			showError(obj.status + ' ' + obj.statusText);
		}
	}
}


function viewFavorites(){
	var html = unescape( readFile(favoritesCache) )
	if(html == null || html == ''){
		writeSetting('UpdateTime', '')
		return
	}
	favoritesHTML = html
	currentlyOpenFolder = null
	document.getElementById('favorites').innerHTML = html
}


function downloadFavorites(){
	var url = baseURL + '?output=xml&num=500&' + Math.round(Math.random() * 1000)
	
	showError('Updating...')
	
	loadXMLDoc(url, 'viewFavorites', onResponseViewFavorites)
}


function onResponseLogin(){
	if( checkReadyState(xmlhttp) ){
		showError('Logged in')
		
		downloadFavorites()
	}
}

function onResponseLogout(){
	if( checkReadyState(xmlhttp) ){
		showError('Logged out')
		
		login()
	}
}

function onResponseViewFavorites(){
	if( ! checkReadyState(xmlhttp) ){
		return
	}
	
	//alert(xmlhttp.responseText)
	
	var responseXML = xmlhttp.responseXML
	if( responseXML == null ){
		showError('Error loading XML')
		return
	}
	
	var response = ''
	
	posts = new Array()
	
	items = responseXML.getElementsByTagName("bookmark"); 

	if(items && items.length != 0 ){
		for(var j=0; j < items.length; j++) {
			addPost(items[j], posts)
		}
	}
	else{
		response += '<b>No favorites found</b>'
	}
	
	var tags = new Array()
	
	addPostsToTags( posts, tags )
	
	if(sortTags == '1'){
		tags.sort()
	}
	
	response += writeTree( tags )
	
	writeFile(favoritesCache, escape( response ))
	
	favoritesHTML = response
	
	showError('Favorites Downloaded')
	
	document.getElementById('favorites').innerHTML = response
	currentlyOpenFolder = null
	
	document.getElementById('searchbox').value = ''
}



function addPostsToTags( postsArray, tagsArray ){
	for(var i=0; i<postsArray.length; i++){
		var tags = postsArray[i].labels.toLowerCase()
		var tagArray = tags.split(',')
		for(var j=0; j<tagArray.length; j++){
			if(tagArray[j].substring(0,1) == '^' && tagArray.length > 1){
				continue
			}
			var position = inArray(tagArray[j], tagsArray)
			if( position >= 0 ){
				tagsArray[position][1].push( postsArray[i] )
			} else {
				tagsArray.push(new Array( tagArray[j], new Array( postsArray[i] ) ) )
			}
		}
	}
}
	
	
function writeTree( tagsArray ){
	var html = ''
	var unfiledHtml = ''
	
	for( var i=0; i<tagsArray.length; i++ ){
		var tag = tagsArray[i][0]
		if(tag.substring(0,1) == '^'){
			unfiledHtml += addLinks( tagsArray[i][1] )
			continue
		}
		html += '<div class="trigger" onclick="expandCollapse(' + i + ')" oncontextmenu="showContextMenu(this);return false" '+
						'onmouseover="this.style.textDecoration=\'underline\'" onmouseout="this.style.textDecoration=\'none\'">'+
					'<img src="images/folderClosed.gif" border="0" id="folder' + i + '">'+
					tag + 
				'</div>\n<div class="branch" id="branch' + i + '">'
		html += addLinks( tagsArray[i][1] )
		html += '</div>\n'
	}
	html += unfiledHtml
	
	return html
}


function addLinks(items){
	if(sortFavorites == '1'){
		items.sort(titleSort)
	}

	var html = ''
	for(var i=0; i<items.length; i++){
		var item = items[i]
		html += '<div class=linkDiv oncontextmenu="showContextMenu(this);return false">'+
					'<a class=link href="' + item.url + '" target=_blank title="' + item.tooltip + '" '+
							'onmouseover="showLink(this.href)" onmouseout="hideLink()" '+
							'" labels="' + item.labels + '" id="' + item.id + '">'+
						'<img src="images/page.gif">' +
						item.title +
					'</a>'+
				'</div>\n'
	}
	return html
}


function titleSort(a, b){
	try{
		a = a.title.toLowerCase()
		b = b.title.toLowerCase()
		if(a < b){
			return -1
		} else {
			return 1
		}
	}
	catch(err){
		return 1
	}
}


function addPost( item , array){
	var title = ''
	var url = ''
	var timestamp = ''
	var labels = ''
	var id = ''
	
	var nodes = item.childNodes
	
	for(var i=0; i < nodes.length; i++){
		var tagName = nodes(i).tagName
		var tagText = nodes(i).text
		
		if(tagName=='title'){
			title = replacer(tagText)
		}
		if(tagName=='url'){
			url = replacer(tagText)
		}
		if(tagName=='timestamp'){
			timestamp = replacer(tagText)
		}
		if(tagName=='id'){
			id = replacer(tagText)
		}
		if(tagName=='labels'){
			var labelNodes = nodes(i).childNodes
			for(var j=0; j<labelNodes.length; j++){
				if(j > 0){
					labels += ','
				}
				labels += labelNodes(j).text
			}
		}
	}
	
	var d = new Date()
	d.setTime(timestamp / 1000)
	var time = d.toLocaleString()
	if(showTooltip == '1'){
		var tooltip = 'URL: ' + url + '\n'
		tooltip += 'Added: ' + time
		
		var MAX_DESCRIPTION_LENGTH = 30
		
		if(title.length > MAX_DESCRIPTION_LENGTH){
			tooltip = title + '\n' + tooltip
		}
		
		/* if(extended){
			tooltip += '\nNote: ' + extended
		} */
	} else {
		var tooltip = ''
	}
	
	array.push( {'title':title,
				'url':url,
				'timestamp':timestamp,
				'labels':labels,
				'tooltip':tooltip,
				'id':id
				} )
}
	

function onResponsePostFavorite(){
	if( ! checkReadyState(xmlhttp) ){
		return
	}

	
	/*var responseXML = xmlhttp.responseXML
	if( responseXML == null ){
		showError('Error loading XML')
		return
	}
	
	try{
		var response = responseXML.getElementsByTagName("result")[0].getAttribute('code') 
	} catch(err){
		showError('bad response Posting...')
		alert(xmlhttp.responseText)
		return
	}*/
	
	
	//if(response == 'done'){
	//alert(xmlhttp.responseText)
	showError('Favorite added!')
	window.setTimeout('downloadFavorites()', 1000)
	//}
	
}


function deleteFavorite(url, id){
	var url = baseURL + 'mark'
	var data = 'dlq=' + id
	
	showError('deleting...')
	loadXMLDoc(url, 'deleteFavorite', onResponseDeleteFavorite, data)
}


function onResponseDeleteFavorite(){
	if( ! checkReadyState(xmlhttp) ){
		return
	}
	var responseXML = xmlhttp.responseXML
	if( responseXML == null ){
		showError('Error loading XML')
		return
	}
	
	
	showError('Favorite deleted!')
	window.setTimeout('downloadFavorites()', 1000)
}


function getCurrentWebsiteURL(){
	return external.get_tab(SECURITY_ID, external.cur_sel).document.URL
}

function getCurrentWebsiteTitle(){
	return external.get_tab(SECURITY_ID, external.cur_sel).document.title
}

function getEditWebsiteURL(){
	return editElement.href
}

function getEditWebsiteTitle(){
	return editElement.innerText
}

function getEditWebsiteNotes(){
	return ''
}

function getEditWebsiteTags(){
	return editElement.labels.replace(/,?\^\w+,?/,'')
}

function displaySettings(){
	configVisible = true
	document.getElementById('favorites').style.display = 'none'
	document.getElementById('settings').style.display = ''
	document.getElementById('message').style.display = 'none'
}

function hideSettings(){
	configVisible = false
	document.getElementById('favorites').style.display = ''
	document.getElementById('settings').style.display = 'none'
	document.getElementById('message').style.display = 'none'
}

function cancel(){
	hideSettings()
	
	if(userName == '' || password == ''){
		var message = '<a href="javascript:displaySettings()">Login first!</a>'
		document.getElementById('favorites').innerHTML = message
	}
}

function save(){
	userNameNew = encodeURIComponent( document.getElementById('userName').value )
	passwordNew = encodeURIComponent( document.getElementById('password').value )

	writeSetting('userName', encodeTxt( userNameNew ))
	writeSetting('password', encodeTxt( passwordNew ))
	
	if(userName != userNameNew){
		writeFile(favoritesCache, '')
		writeSetting('UpdateTime', '')
	}

	location.reload()
}

function setSettingsForm(){
	document.getElementById('userName').value = userName
	document.getElementById('password').value = password
}


function inArray( text, array ){
	for(var i=0; i<array.length; i++){
		if(text == array[i][0]){
			return i
		}
	}
	return -1
}

function replacer(s){
	return s.replace(/&amp;/g,'&').replace(/&quot;/g,'"');
}